<?php

//////////
///
///   download.inc.php
///
//////////
///
///   download_add($backdoor, $filename)
///   download_del($download)
///   download_enum($backdoor)
///   download_get($download)
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['download.add']['function'] = 'download_add';
//   $dm['download.add']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                  $xmlrpcString,     // $backdoor
//                                                  $xmlrpcString));   // $filename
}

if($al & AL_SERV) {
   $dm['download.del']['function'] = 'download_del';
//   $dm['download.del']['signature'] = array(array($xmlrpcBoolean,   // return value
//                                                  $xmlrpcInt));     // $download
}

if($al & AL_SERV) {
   $dm['download.enum']['function'] = 'download_enum';
//   $dm['download.enum']['signature'] = array(array($xmlrpcArray,      // return value
//                                                   $xmlrpcString));   // $backdoor
}

if($al & AL_SERV) {
   $dm['download.get']['function'] = 'download_get';
//   $dm['download.get']['signature'] = array(array($xmlrpcStruct,   // return value
//                                                  $xmlrpcInt));    // $download
}



/***************\
*   FUNCTIONS   *
\***************/

function download_add($backdoor, $filename)
{
   $err_map[1452] = $GLOBALS['err_download']['invbackdoor'];

   $ret = db_escape(array(&$backdoor,
                          &$filename));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = trace('download.add', $backdoor, $filename);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "INSERT INTO `download` (`backdoor_id`, ";
   $sql .=                       "`filename`) ";
   $sql .= "VALUES ('$backdoor_id', ";
   $sql .=         "'$filename')";

   return db_query($sql, $err_map);
}

function download_del($download_id)
{
   $ret = db_escape(array(&$download_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "DELETE FROM `download` ";
   $sql .= "WHERE `download_id` = $download_id";

   return db_query($sql);
}

function download_enum($backdoor)
{
   $ret = db_escape(array(&$backdoor));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "SELECT `download_id` AS `download` ";
   $sql .= "FROM `download` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_download']['nodownload'];
   }

   foreach($ret as &$r) {
      $r = (integer)$r->download;
   }

   return $ret;
}

function download_get($download_id)
{
   $ret = db_escape(array(&$download_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `filename` ";
   $sql .= "FROM `download` ";
   $sql .= "WHERE `download_id` = $download_id";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_download']['empty'];
   }

   return $ret[0];
}

?>
